    // Screen Editor For Linux Developed by RAGHUNANDAN K.S.

#include <panel.h>
#include <curses.h>

#define MAXCOL 70
#define TAB  8  

enum {T=0,L=1,R=2,B=3};    //Top,Left,Right,Bottom
struct tag
{      	char info;
	struct tag *l,*r;
};

struct headtag		//Header Node
{	struct tag *first,*last;
	struct headtag *u,*d;
};

typedef struct tag NODE;
typedef struct headtag HEAD;

WINDOW *wout,*wstatus,*wbor;	//Global
PANEL  *pout,*pstatus,*pbor;
int m,flag,px,py,Save,SaveAs;
int S[4],forecolor,backcolor;
char fname[30];
HEAD *rowp, *MHead;
NODE *colp;
int lnbr;

int Menu(char *[], int [], int, int, int, int, int);
int ConfirmMenu();
int FileMenu();
int EditMenu();
int SetupMenu();
int ColorMenu();
int AboutMenu();
int InsertMode();
int PageSetup(int);
void StatusBar(char[]);
void MainMenu( int);
void KulaGothra();
void KulaGothra1();
void KulaGothra2();
int AboutMenu();
void ColorSet(int);
void Initialize();
void RefreshAll();
void UpArrow(int);
void DownArrow(int);
void Refresh(PANEL*);
void Labelesh();
void Helpesh();
NODE *InsAfter(NODE*, chtype );
void InsWord(char[]);
void InsInBet( NODE*, chtype);
void InsLine(HEAD*);
void InsHeadNode();
void Delete(HEAD*, NODE*);
int DelWord();
void DelLine(HEAD*);
void DelInBet(NODE*, NODE*);
void EnterInBet();
void WriteFromFile();
void WriteToFile();
int JoinToPrevLine(NODE*);
void AskWord(char*, char []);
int Gety(HEAD*, NODE*);
int Getx(HEAD*, NODE*);	
void Increment(chtype);
int F_NewOpen(int);
void F_Exit();

int main()
{
	chtype ch,val,item[]={'F','E','P','C','A','I'};
	initscr();                      //File, Edit, Page, ....s
	start_color();
   Labelesh();
	Initialize();
   KulaGothra1();
	keypad(wout,TRUE);
	val=1;
	while(1)
	{
		MainMenu(-1);   //Highlight nothing in MainMenu
		if(val){ Refresh(pbor); Refresh(pout); }
		
		if(flag)ch=item[m];   //If i/p is Left or Right Arrow
		else ch=wgetch(wout);
		if(isalpha(ch))ch=toupper(ch); //If lowercase
		val=0;
		switch(ch)
		{	
			 case 'F': val=FileMenu();  m=0;break;
			 case 'E': val=EditMenu();  m=1;break;
			 case 'P': val=SetupMenu(); m=2;break;
			 case 'C': val=ColorMenu(); m=3;break;
			 case 'A': val=AboutMenu(); m=4;break;
			 case 'I': case 331: val=InsertMode();break;
			 case KEY_F(1)  : Helpesh(); m=5; break;
			 case KEY_F(4)  : case 14: F_NewOpen(1); m=5; break;
			 case KEY_F(3)  : case 15: F_NewOpen(2); m=5; break;
			 case KEY_F(10): case 24: F_Exit(); break;
          default : break;
		}
		if(val==-1)   {  m=((m--<1)?4:m); flag=1; } //Left Key returned
		else if(val==-2)  {  m=((m++>3)?0:m); flag=1; }  // Right Key returned
		else if(val==-3) flag=0;   //Esc returned
		else if(m==5)flag=1; //F(3)/F(4) pressed
	}
}

void Initialize()
{

	forecolor=1, backcolor=6;
	
	init_pair(01,forecolor,backcolor);
	init_pair(05,6,4);
	
	wout=newpad(2000,MAXCOL+1);  //Main Editing Window
	pout=new_panel(wout);
	wbkgd(wout,COLOR_PAIR(1));
	
	wstatus=newwin(1,80,0,0);    //StatusBar Window
	pstatus=new_panel(wstatus);
	wbkgd(wstatus,COLOR_PAIR(5));
	mvwprintw(wstatus,0,1,"VIT->025");
	
	wbor=newwin(23,80-7,1,7);  //Border Window
	pbor=new_panel(wbor);
	wbkgd(wbor,COLOR_PAIR(1));
	box(wbor,ACS_VLINE,ACS_HLINE );
			
	noecho();
	Save=1,SaveAs=0;
	strcpy(fname,"noname.doc");
      	
      	NODE *p=new NODE;
	MHead= new HEAD;  //Main HeaderNode
	MHead->u=NULL;
	MHead->d=NULL;
	MHead->first=p;
	p->l= NULL;
	p->r=NULL;
	rowp=MHead;
	colp=InsAfter(MHead->first,'\n');
	MHead->last=colp;
	
	int i;
	for(i=0;i<4;i++)S[i]=0;  //All the 4 margins = 0
	
	px=Getx(rowp,colp);

	m=0,flag=0;
	keypad(wout,TRUE);
}

int PageSetup(int n)
{
	PANEL *ppage;
	WINDOW *wpage;
	char *names[]={"Top   : ","Left  :","Right :"};
	
	wpage=newwin(3,20,9,30);
	ppage=new_panel(wpage);
	wbkgd(wpage,COLOR_PAIR(0));
	box(wpage,ACS_VLINE,ACS_HLINE);
	echo();
	mvwprintw(wpage,1,3,"%s",names[n-1]);
	mvwscanw(wpage,1,10,"%d",&S[n-1]);
	px=Getx(rowp,colp);
	return( InsertMode() );
		
}

int InsertMode()
{
	chtype ch;
	int Rflag;
	HEAD *h;
	NODE *n;
	int a;
	
	Refresh(pbor);
	Refresh(pout);
	noecho();
	Rflag=1;
	while(1)
	{
	    px=Getx(rowp,colp);
		StatusBar("INS");
	    wmove(wout,py,px);

	    if(Rflag)  RefreshAll();  //Write the whole Data-structure
	    prefresh(wout,(py/21)*21,0,2,8,22,78);
	    ch=wgetch(wout);
	    switch(ch)
	    {	
			case KEY_UP	:	UpArrow(1); Rflag=0; break;
				
			case KEY_DOWN	:	DownArrow(1); Rflag=0; break;
				
		/*PGUP*/case 339	: 	UpArrow(21); Rflag=0; break;
                 	
     /*PGDN*/ case 338	:  DownArrow(21); Rflag=0; break;
	
	  /*ESC*/	case 27		:	StatusBar("ESC"); return -3;
					
          /*REFRESH*/ 	case KEY_F(5) 	:	Rflag=1; break;
			
			case KEY_RIGHT	:	if(colp->r==NULL)
						{
							beep();
							break;
						}
						colp=colp->r;					
						px=Getx(rowp,colp);
						Rflag=0;
						break;
					
			case KEY_LEFT	:	if(colp->l==rowp->first)
						{	beep();	
							break;
						}
						colp=colp->l;
                        			px=Getx(rowp,colp);
						Rflag=0;
						break;
					
			case KEY_BACKSPACE:	
						if(colp->l==rowp->first)
						{	JoinToPrevLine(colp);
							Rflag=1;
						}
						else
						{	DelInBet(colp->l->l, colp);
							mvwdelch(wout,py,px);
							Rflag=0;
						}
						py=Gety(rowp,rowp->first->r);
						px=Getx(rowp,colp);
						Rflag=1;
						Save=0;
						break;
					
	/*DEL*/		case 330	:	if(colp==rowp->last)
						{	h=rowp->d;
							if(!h) beep();
							 //last line,last char
							else
							{	colp=h->first->r;
								rowp=h;
								JoinToPrevLine(colp);
							}
						}
						else
							Delete(rowp,colp);
						 Save=0;
						 Rflag=1;
						 break;
					
	/*HOME*/	case 262	:	 colp=rowp->first->r;
						 px=Getx(rowp,colp);
						 Rflag=0;
						 break;
					
	/*END*/		case 360	:	 colp=rowp->last;
						 px=Getx(rowp,colp);
						 Rflag=0;
						 break;	
			
	/*ENTER*/	case  10	:	py++;
						px=S[L];
					
						if(rowp->d==NULL && colp->r==NULL)
						{	InsHeadNode();
							Rflag=0;
						}
						else
						{	EnterInBet();
							Rflag=1;
						}
						Save=0;
						break;
			
			case KEY_F(1)	:	Helpesh(); break;
			case KEY_F(8)  : DownArrow(lnbr);break ;
			case KEY_F(9)	:  a=colp;
									UpArrow(a);	break;
	/* ^W */	case 23		:	InsWord("\0"); break;
	/* ^L */	case 12		:	InsLine(rowp); break;
	/* ^Q */	case 17		:	DelWord(); break;
	/* ^Y */	case 25		:	DelLine(rowp); break;
	case KEY_F(4):	case 14		: 	F_NewOpen(1); break; //New
	case KEY_F(3):	case 15		:	F_NewOpen(2); break; //Open
	case KEY_F(2):	case 19		:	WriteToFile(); break; //Save
	case KEY_F(10):	case 24		:	F_Exit(); break;

			default		:	InsInBet(colp,ch);
						if(ch=='\t')
							px=Getx(rowp,colp);
						else
						{	mvwinsch(wout,py,px,ch);
							Increment(ch);
						}
						if(rowp->d==NULL && colp->r==NULL)
							Rflag=0;
						else  Rflag=1;
						Save=0;
		}// switch
	}//while
}//InsertMode

int F_NewOpen(int pos)
{	
	 Refresh(pout);
	 int x=((Save)?5:ConfirmMenu()); //If not saved, get confirmed
	 Refresh(pout);
	 switch(x)	
	 {    case -3: 	return -3;
	      case  3: 	WriteToFile();  //yes
	      case  4:              //no
	      case  5:	Refresh(pout);
			wclear(wout);
			delwin(wout);
			Initialize();
			if(pos==2 || pos=='O' )WriteFromFile();
	}
}


void F_Exit()
{
	 KulaGothra2();
	 Refresh(pout);
	 int x=((Save)?4:ConfirmMenu()); //Confirm if not saved
	 Refresh(pout);
	 switch(x)
	 {    case  3:	WriteToFile();
	      case  4:	endwin();   exit(0);
	 }
}


void EnterInBet()
{
	NODE *beg, *end;
	beg=colp;
	end=rowp->last;
	NODE *p=InsAfter(colp->l,'\n');
	/* Now rowp has got incremented */
	rowp->last=p;
	InsHeadNode();
	NODE *delp=rowp->last;
	p=rowp->first;
	p->r=beg;
	beg->l=p;
	rowp->last=end;
	colp=beg;
   lnbr++;
}


void UpArrow(int no)
{
	int i;
	for(i=1;i<=no;i++) // no = 1 for UpArrow, 21 for PgUp
	{	if(rowp->u==NULL)
		{
			beep();
			break;
		}
		rowp=rowp->u;
		colp=rowp->first->r;
		px=Getx(rowp,colp);
	}
}

void DownArrow(int no)
{
	int i;
	for(i=1;i<=no;i++)
	{	if(rowp->d==NULL)
		{	beep();
			break;
		}
		rowp=rowp->d;
		colp=rowp->first->r;
		px=Getx(rowp,colp);
	}
}

void RefreshAll()
{
	HEAD *hp;
	NODE *np;
	int i,j,k,m;
	char ch;
	
	i=S[T], j=S[L];
	wclear(wout);

	echo();

	for(hp=MHead; hp!=NULL; hp=hp->d)
	 {   for(np=hp->first->r; np!=NULL ; np=np->r)
	     {	ch=np->info;
	     	if(np->info=='\t')k=TAB;
	     	else k=1;
	     	mvwaddch(wout,i,j,ch);
		if(np->info=='\n')break;
		for(m=0; m<k; m++)
	     	{     	j++;
		      	if(j>MAXCOL-S[R])
		      	{	i++;
		      		j=S[L];
		      	}
		}
	     }
	     i++;
	     j=S[L];
	 }
	 wmove(wout,py,px);
  }

void Refresh(PANEL *p)
{	top_panel(p);
	update_panels();
	doupdate();
}

void StatusBar(char *StatusName)
{
	init_pair(17,5,4);
	mvwprintw(wstatus,0,11,"   ","   ");
	mvwprintw(wstatus,0,11,"R=%d,C=%d",py,px);
	mvwprintw(wstatus,0,34,"      ");
	mvwprintw(wstatus,0,34,"%s",fname);
	mvwprintw(wstatus,0,55,"    ");
	mvwprintw(wstatus,0,55,"%s",StatusName);
	mvwprintw(wstatus,0,71,"%s","RAGHU'S EDIT");
	mvwchgat(wstatus,0,71,12,A_BLINK|A_BOLD,17,NULL);
	Refresh(pstatus);
}

void Labelesh()
{
	WINDOW *w;
	PANEL *p;
	w=newwin(1,79,24,0);
	p=new_panel(w);
	Refresh(p);
	init_pair(16,COLOR_CYAN,COLOR_BLUE);
	wbkgd(w,COLOR_PAIR(16));
	mvwaddstr(w,0,1,"Press ESC followed by the hotkey to activate the menus. Press \"I\" for InsMode");
	wrefresh(w);
}

void MainMenu(int k)
{
	PANEL *pmenu;
	WINDOW *wmenu;
	char *name[]={"FILE", "EDIT", "PAGE", "COLOR","ABOUT" };
	int arr[]={1,1,1,1,1};  //Hotkey positions
	int i,j=0;

	wmenu=newwin(23,7,1,0);
	pmenu=new_panel(wmenu);
	init_pair(02,7,1);
	wbkgd(wmenu,COLOR_PAIR(16)|A_BOLD);
	box(wmenu,ACS_VLINE,ACS_HLINE);
	
	for(i=1;i<=5*4;i+=4)
	{
		mvwaddstr(wmenu,i,1,name[j]);
		mvwchgat(wmenu,i,arr[j],1,A_DIM,02,NULL); //Hotkey
		j++;
	}
	if(k>-1)  //If something is to be highlighted
	    mvwchgat(wmenu,k*4+1,1,strlen(name[k]),A_REVERSE,02,NULL);
	wrefresh(wmenu);
	Refresh(pmenu);
}

int Menu(char* name[], int arr[], int SR,int SC,int NR,int NC,int SH)
{							
	PANEL *ppop;
	WINDOW *wpop;
	int i,oldi,j,k,flag;
	int ch;
	
	wpop=newwin(NR,NC,SR,SC);
	ppop=new_panel(wpop);
	init_pair(11,7,1);
	init_pair(12,6,1);
	init_pair(13,5,1);
	init_pair(14,4,1);
	box(wpop,ACS_VLINE,ACS_HLINE);
	wbkgd(wpop,COLOR_PAIR(14)|A_BOLD);
	Refresh(ppop);
	
	j=NR-2, i=SH;
	keypad(wpop,TRUE);
	while(1)
	{	
		for(k=1;k<=NR-2;k++)
		{
			mvwaddstr(wpop,k,2,name[k-1]);
			mvwchgat(wpop,k,2,strlen(name[k-1]), A_NORMAL | A_BOLD, 11, NULL);
			mvwchgat(wpop,k,arr[k-1],1,A_UNDERLINE,14,NULL);
		}
		mvwchgat(wpop,i,2,strlen(name[i-1]),A_REVERSE,14,NULL); //Selection blinked
		
		flag=0;	//function returns only when flag=1
		ch=wgetch(wpop);
		switch(ch)
		{
			case KEY_UP   :	i=((i==SH)?j:i-1);break;
			case KEY_DOWN :	i=((i==j)?SH:i+1);break;
			case KEY_LEFT :	flag=1; ch=-1; break;
			case KEY_RIGHT:	flag=1; ch=-2; break;
			case 27       :	flag=1; ch=-3; break;
			case 10       :	flag=1; ch=i; break; //return position
			default	      :	for(k=SH-1;k<NR-2;k++)
				 	{	ch=toupper(ch);
				        	if( ch==name[k][arr[k]-2] )
						    flag=1; //Hotkey pressed
					}
					if(!flag)beep(); //Fault key pressed
			 	
		}
		if(flag)
		{	MainMenu(-1); //Remove highlighting from MainMenu
			Refresh(pbor);
			Refresh(pout);
			return ch;
		}
	}
}

int ConfirmMenu()
{	
	char *name[]={ "Want to save the file?"," ","=>Yes","=>No" };
	int hotkeys[]={50,50,4,4}; //dummy,dummy,4,4
	int SR=8,SC=25,NR=6,NC=27, SH=3,pos;
	 //SR=Starting Row, SC=Starting Column,
	 //NR=No.of Rows, NC=No.of Columns, SH=Start Highlight
	pos=Menu(name,hotkeys,SR,SC,NR,NC,SH);
	switch(pos)
	{
		case -3: return(-3); // Esc was returned
		case 3 :  case 'Y': return(3); //Yes. Want to save
		case 4 :  case 'N': return(4); //No.
		default: beep();return(-3);
	}
}

int FileMenu()
{
	char *name[]={ "New","Open","Save","Save As","Delete","Exit" }, carr[20];
	int x,hotkeys[]={2,2,2,7,2,3};
	int SC=7,SR=0*4+1,NR=8,NC=15, SH=1,pos;
	MainMenu(0);  //Highlight "File"(name[0]) in Mainmenu
	pos=Menu(name,hotkeys,SR,SC,NR,NC,SH);
	switch(pos)
	{
		case -1: 		return(-1); //Left Key returned
		case -2: 		return(-2); //Right Key returned
		case -3: 		return(-3); //Esc
		case  1: case 'N':
		case  2: case 'O':	F_NewOpen(pos);  break;;	
		case  6: case 'X':	F_Exit(); break;
		case  4: case 'A': 	SaveAs=1;
		case  3: case 'S': 	WriteToFile();  break;
		case  5: case 'D':	wclear(wout);
					strcpy(carr,"rm ");
					strcat(carr,fname);
					system(carr);
					Initialize();
	}
	return( InsertMode() ); //GetInto InsertMode
}
	
int EditMenu()
{
	char *name[]={"Insert word","iNsert line",
		      "deLete word","Delete line","document Begin","document End"};
	int i,hotkeys[]={2,3,2,3,2,3};
	int SC=7,SR=4*1+1, NR=8,NC=20, SH=1,pos;
	int a;
	MainMenu(1);
	pos=Menu(name,hotkeys,SR,SC,NR,NC,SH);
	switch(pos)
	{
	case  1:	 case 'I':	InsWord("\0"); 	break;
	case  2:	 case 'N':	InsLine(rowp); 	break;
	case  4:	 case 'L': 	DelLine(rowp); 	break;
	case  3:	 case 'D':	DelWord(); 	break;
	case  5:	 case 'B':  a=colp;
									UpArrow(a);  break;
	case  6:	 case 'E':  DownArrow(lnbr);break;	
		case -1: 		return(-1);
		case -2: 		return(-2);
		case -3: 		break;
		default:  		beep();
	}
	return( InsertMode() );
}

int SetupMenu()
{
	char *name[]={"Top", "Left", "Right"};
	int hotkeys[]={2,2,2};
	int SC=7,SR=2*4+1, NR=5, NC=18, SH=1,pos;
	MainMenu(2);
	pos=Menu(name,hotkeys,SR,SC,NR,NC,SH);
	switch(pos)
	{
		case -1: return(-1);
		case -2: return(-2);
		case -3: break;
		case  1: case 2: case 3: case 4:
		default: switch(pos)
			 {
				case 'T': pos=1; break;
				case 'L': pos=2; break;
				case 'R': pos=3; break;
			 }
			 PageSetup(pos);
			 break;
	}
	return( InsertMode() );
}

int ColorMenu()
{
	char *name[]={"Fontcolor", "Background"};
	int hotkeys[]={2,2};
	int SC=7, SR=4*3+1, NR=4, NC=18, SH=1, pos, k;
	MainMenu(3);
	pos=Menu(name,hotkeys,SR,SC,NR,NC,SH);
	switch(pos)
	{       case  1: case 'F':	ColorSet(1);   break;	
		case  2: case 'B':	ColorSet(2);   break;
		case -1: 		return -1;
		case -2: 		return -2;
		case -3: 		return -3;
	}
	return( InsertMode() );
}

void ColorSet(int k)
{
	char *name[]={"Black","Red","Green","brOwn",
			"bLue","Magenta","Cyan","White"};
	int hotkeys[]={2,2,2,4,3,2,2,2};
	int SR=7, SC=30, NR=10, NC=15, SH=1, pos;
	pos=Menu(name,hotkeys,SR,SC,NR,NC,SH);
	switch(pos)
	{
		case 1: case 'B': pos=1; break;
		case 2: case 'R': pos=2; break;
		case 3: case 'G': pos=3; break;
		case 4: case 'O': pos=4; break;
		case 5: case 'L': pos=5; break;	
		case 6: case 'M': pos=6; break;
		case 7: case 'C': pos=7; break;
		case 8: case 'W': pos=8; break;
	}
	if(k==1)forecolor=pos-1;
	else backcolor=pos-1;
	init_pair(1,forecolor,backcolor);
	Refresh(pbor);
	Refresh(pout);
}

int AboutMenu()
{
	char *name[]={"Help", "About"};
	int hotkeys[]={2,2};
	int SC=7,SR=4*4+1, NR=4,NC=15, SH=1, pos;
	MainMenu(4);
	pos=Menu(name,hotkeys,SR,SC,NR,NC,SH);
	switch(pos)
	{
		case -1: 		return(-1);
		case -2: 		return(-2);
		case 1: case 'H':	Helpesh(); break;
		case 2: case 'A':	KulaGothra(); break;
	}
	return( InsertMode() );
}

void KulaGothra()
{
   WINDOW *wmy;
	PANEL *pmy;
	char *name[]={	"This Screen Editor Is developed by","NAME     : RAGHUNADAN K.S.",
						"COLLEGE  : VIT","ROLL NO. : 1VK98CS025"," Report Bugs at","raghu_nandan_in@yahoo.com" };
	
	init_pair(20,7,1);
	wmy=newwin(8,38,9,18);
	pmy=new_panel(wmy);
	box(wmy,ACS_VLINE,ACS_HLINE);
	wbkgd(wmy,COLOR_PAIR(2));
	
	echo();
	int i;
	for(i=0; i<8; i++)
	{       mvwprintw(wmy,i+1,1,"%s",name[i]);
		if(i==1)mvwchgat(wmy,i+1,11,26,A_BLINK|A_BOLD,20,NULL);
	}
	Refresh(pbor);
	Refresh(pout);
	Refresh(pmy);
	noecho();
	wgetch(wmy);
}



void Helpesh()
{
	WINDOW *w;
	PANEL *p;
	char *name[]={ 	"Ctrl+N (F4) : New", "Ctrl+O (F3) : Open","Ctrl+S (F2) : Save",
			"Ctrl+X (F10): Exit","Ctrl+W : Insert Word","Ctrl+L : Insert Line","Ctrl+Q : Delete Word",
			"Ctrl+Y : Delete Line" ,"(F5) : Refresh","(F1) : Help","(F8) : Document End ",
			"(F9) : Document Begin","","Press Any key to Exit"};
	w=newwin(18,24,3,79-24);
	p=new_panel(w);
	init_pair(20,COLOR_RED,COLOR_WHITE);
	wbkgd(w,COLOR_PAIR(20));
	box(w,ACS_VLINE,ACS_HLINE);
	
	echo();
	int i;
	for(i=0; i<14; i++)mvwaddstr(w,i+1,2,name[i]);
	Refresh(pbor);
	Refresh(pout);
	Refresh(p);
	noecho();
	wgetch(w);
}
			
//******************************************** backend file

int Gety(HEAD *rp,NODE *cp)
{
	HEAD *p;
	NODE *q;
	int y=S[T],x=S[L]-1,i,k;
	for(p=MHead; p!=rp; p=p->d)
	{      for(q=p->first->r; q!=NULL; q=q->r)
		{	k=1;
	       		if(q->info == '\t')k=TAB; //if TAB, move 8 positions
		       	for(i=0; i<k; i++)
		       	{	x++;
			       	if(x>MAXCOL-S[R])
			       	{	y++;
		       			x=S[L]-1;
			       	}
			}
		}
		y++;
		x=S[L]-1;
	}
	return y;
}

int Getx(HEAD *h, NODE *n)
{
	NODE *p;
	int x=S[L],k,i;
	py=Gety(rowp,colp);
	for(p=h->first->r; p!=n; p=p->r)
	{	k=1;
		if(p->info=='\t')k=TAB;
		for( i=0; i<k; i++)
		{	x++;
			if(x>MAXCOL-S[R])
			{	py++;
				x=S[L];
			}
		}
	}
	return x;
}
	
void AskWord(char *carr, char name[])
{
	WINDOW *w;
	w=newwin(3,65,10,10);
	box(w,ACS_VLINE,ACS_HLINE);
	
	mvwaddstr(w,1,2,name);
	wrefresh(w);
	int k=strlen(name)+2;
	echo();
	mvwgetnstr(w,1,k,carr,70-k); //scaning limited to 70-k charecters
	noecho();
}

void InsWord(char name[])
{
	char carr[70],c;
	int i;
	if(strcmp(name,"\0")==0)
 	        AskWord(carr,"Enter Word: ");
 	else  strcpy(carr,name);

	InsInBet(colp,' ');
	Increment(' ');
	for(i=0; ((c=carr[i])!='\0'); i++)
	{	InsInBet(colp,c);
		Increment(' ');
	}
	InsInBet(colp,' ');
	Increment(' ');
	RefreshAll();
}

void Increment(chtype ch)
{
	int i,k;
	if(ch == '\t') k=TAB;
	else    k=1;
	for(i=0;i<k;i++)
	{	px++;
		if(px>MAXCOL-S[R])
		{	py++;
			px=S[L];
		}
	}
}	
	
void DelInBet(NODE *beg, NODE *end)
{	
	NODE *p=beg->r;
	beg->r=end;
	end->l=beg;
	delete(p);
	lnbr--;
}

int JoinToPrevLine(NODE *p)
{
	HEAD *h=rowp->u;
	if(h==NULL)
	{	beep();
		return 0;
	}
	NODE *beg,*end;
	
	beg=h->last->l;
	end=colp;
	beg->r=end;
	end->l=beg;
	NODE *q=h->last;
	delete(q);
	h->last=rowp->last;
	
	DelLine(rowp);
	rowp=h;
	colp=end;
	lnbr--;
}

NODE* InsAfter(NODE *cp, chtype ch)
{
	NODE *p;
	p=new NODE;
	p->info=(char)ch;
	p->r=NULL;
	p->l=cp;
	cp->r=p;
	return p;
lnbr++;
}

void InsHeadNode()
{
	HEAD *rb,*ra;
	HEAD *rp=new HEAD;
	NODE *dum=new NODE;
	NODE *p= new NODE;
	
	rp->first=dum;
	rp->last=p;
	dum->l=NULL;
	dum->r=p;
	p->l=dum;
	p->r=NULL;
	p->info='\n';
	
	ra=rowp;
	rb=rowp->d;
	if(rb)
	{
		rp->d=rb;
		rb->u=rp;
	}
	else
	{
		rp->d=NULL;
	}
	rp->u=ra;
	ra->d=rp;
	
	rowp=rp;
	colp=rowp->last;
lnbr++;
}

void InsInBet( NODE *cp, chtype ch )
{
	NODE *p=new NODE;
	p->info=(char)ch;
	
	NODE *beg=cp->l, *end=cp;
	p->l=beg;
	p->r=end;
	beg->r=p;
	end->l=p;
}

void InsLine(HEAD *hb)
{
	NODE *np,*dum;
	HEAD *ha, *hp;
	hp=new HEAD;
	np=new NODE;
	dum=new NODE;
	
	hp->first=dum;
	dum->l=NULL;
	dum->r=np;
	np->l=dum;
	np->r=NULL;
	np->info='\n';
	hp->last=np;
		
	ha=hb->u;
	if(ha==NULL)
	{	hb->u=hp;
		hp->d=hb;
		hp->u=NULL;
		MHead=hp;
	}
	else
	{	hb->u=hp;
		hp->d=hb;
		hp->u=ha;
		ha->d=hp;
	}
	rowp=hb;
	colp=rowp->first->r;
	wmove(wout,py,px);
	winsertln(wout);
	lnbr++;
}	

void Delete(HEAD *h, NODE *p)
{
	NODE *beg=p->l;
	NODE *end=p->r;
	
	if(p->info=='\n')  //if only '\n' present
		DelLine(h);
	else
	{	beg->r=end;
		end->l=beg;
		colp=end;
		delete(p);
	}
}

int DelWord()
{
	if(colp==rowp->last)
 	{	beep();
  		return 0;
    	}
	
	NODE *beg,*end;
	beg=colp;
	end=colp;
	
	while(1)
	{	if( (beg->l == rowp->first) || (beg->l->info == ' ' ) )
			break;
		beg=beg->l;
	}
	while( 1)
	{ 	if( (end->r == rowp->last) || (end->info == ' ') )
			break;
		end=end->r;
	}
	end=end->r;
	colp=beg;
	while( colp!=end )
	        Delete(rowp,colp);
}

void DelLine(HEAD *hp)
{
	char oldname[30];
	HEAD *ha, *hb;
	ha=hp->u;
	hb=hp->d;
	
	if(ha==NULL && hb==NULL)
	{	delete(MHead);
		wclear(wout);
		strcpy(oldname,fname);
		Initialize();
		Save=0;
		strcpy(fname,oldname);
	}
	else
	{	if(ha==NULL)
		{
			hb->u=NULL;
			MHead=hb;
			rowp=hb;
		}
		else if(hb==NULL)
		{
			ha->d=NULL;
			rowp=ha;
		}
		else
		{
			ha->d=hb;
			hb->u=ha;
			rowp=hb;
		}
		delete(hp);
		colp=rowp->first->r;
	}
	lnbr--;
}

void WriteToFile()
{
	FILE *fp;
	int i,j;
	int ch;

	StatusBar("SAVE");
	if(SaveAs) //if SAVEAS option was selected
	{	AskWord(fname,"Enter Filename: ");
		SaveAs=0;
	}
	else if(strcmp(fname,"noname.doc")==0) //Ask for new Filename
		AskWord(fname,"Enter Filename: ");
	
	fp=fopen(fname,"w");
	for(HEAD *hp=MHead; hp!=NULL; hp=hp->d)
	      for(NODE *np=hp->first->r; np!=NULL; np=np->r)
	             fputc(np->info,fp);
	fclose(fp);
	
	Save=1;
	StatusBar("ESC");
	Refresh(pbor);
	Refresh(pout);
}

void WriteFromFile()
{
	FILE *fp;
	char ch;
	
	if(wout)delwin(wout); //Close previous file before opening new file
	if(MHead)delete(MHead);
                 Initialize();
	
	do{	AskWord(fname,"Enter File: ");
	}while( !(fp=fopen(fname,"r")) );   
		//Ask again if the specified file does't exist
	
	while((ch=fgetc(fp))!=EOF)
	 {	if(ch=='\n')
	 	{	InsHeadNode();
	 		continue;
		}
	  	InsInBet(colp,ch);
		lnbr+=1;
 	 }
	 rowp=MHead;
	 colp=rowp->first->r;
	 RefreshAll();
	 Save=1;
}

void KulaGothra1()
{
   WINDOW *wmy;
	PANEL *pmy;
	char *name[]={	"		WELCOME		","This Screen Editor Is developed by","NAME     : RAGHUNADAN K.S.",
						"COLLEGE  : VIT","ROLL NO. : 1VK98CS025", };
	
	init_pair(20,7,1);
	wmy=newwin(7,38,8,18);
	pmy=new_panel(wmy);
	box(wmy,ACS_VLINE,ACS_HLINE);
	wbkgd(wmy,COLOR_PAIR(1));

	echo();
	int i;
	for(i=0; i<8; i++)
	{       mvwprintw(wmy,i+1,1,"%s",name[i]);
      if(i==0)mvwchgat(wmy,i+1,0,38,A_BLINK|A_BOLD,20,NULL);
		if(i==2)mvwchgat(wmy,i+1,11,26,A_BLINK|A_BOLD,20,NULL);
	}
	Refresh(pbor);
	Refresh(pout);
	Refresh(pmy);
	noecho();
	wgetch(wmy);
}

void KulaGothra2()
{
        WINDOW *wmy;
	PANEL *pmy;
	char *name[]={	"		Thank You		","This Screen Editor Is developed by","NAME     : RAGHUNADAN K.S.",
						"COLLEGE  : VIT","ROLL NO. : 1VK98CS025", };

	init_pair(20,7,1);
	wmy=newwin(7,38,8,18);
	pmy=new_panel(wmy);
	box(wmy,ACS_VLINE,ACS_HLINE);
	wbkgd(wmy,COLOR_PAIR(2));

	echo();
	int i;
	for(i=0; i<8; i++)
	{       mvwprintw(wmy,i+1,1,"%s",name[i]);
		if(i==0)mvwchgat(wmy,i+1,0,38,A_BLINK|A_BOLD,20,NULL);
		if(i==2)mvwchgat(wmy,i+1,11,26,A_BLINK|A_BOLD,20,NULL);
	}
	Refresh(pbor);
	Refresh(pout);
	Refresh(pmy);
	noecho();
	wgetch(wmy);
}